// u5_temperatur.cpp : Musterlsung Aufgabe 2 Serie 5
//
// Autor: Christoph Niederberger, 2003
//	      niederberger@inf.ethz.ch
//

/* Sonderflle

Mgliche Sonderflle:

1. Temperatur konstant
Auswirkungen: keine Kusrvernderung, kein Anstieg
- Ausgabe 1 und 2 ist falsch, da 0 als grsste Vernderung ausgegeben wird.

2. Temperatur monoton fallend
Auswirkungen: kein Anstieg
- Ausgabe 2 gibt zwei mal 0 als grsster Anstieg aus

3. Temperatur nur einmal steigend
Auswirkungen: nur ein Anstieg
- Ausgabe 2 gibt fr den zweiten Wert 0 als grsster Anstieg aus

4. Mehrere gleich hohe Vernderungen
Auswirkungen: Es werden nich alle Flle ausgegeben
Abhilfe: Bestimmen der Anzahl gleich hoher Anstiege und Ausgabe aller Flle

Hinweis:
========
Die vorliegende Musterlsung deckt nur die ersten drei Flle ab. 
Der vierte Fall wurde nicht implementiert!

Mit Hilfe der Funktion loadValues() knnen diese Flle erzeugt werden.
Dazu mssen die entsprechenden Zeilen auskommentiert werden, welche 
die Daten erzeugen.

*/

#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <iostream>

using namespace std;

// forward declaration of the function loadValues()
void loadValues(float* arr);

int main()
{
	// the array with values
	float Temp[30];

	// load the values into the array
	loadValues(Temp);

	// output values
	for (int i=0; i<30; i++)
	{
		cout << i+1 << ".Tag : Temp[" << i << "] = " << Temp[i] << endl;
	}
	cout << endl << endl ;

/////////////////////////////////////////////////////////////////////////////////
// Grsste Vernderung
/////////////////////////////////////////////////////////////////////////////////

	// Declaration of variables
	//-------------------------

	// index of the largest change
	int max_index = -1;
	// value of the largest change
	float max_change = 0;


	// Search the array
	//-----------------

	// start at index 1!
	// if starting at index 0, we would access Temp[-1] which is not defined
	for (int index = 1; index < 30; index++)
	{
		// determine difference 
		float diff = Temp[index] - Temp[index - 1];

		// if (diff*diff) is larger than (max_change*max_change) then update values
		// remark: using the square replaces the abs() function
		if ((diff*diff) > (max_change*max_change))
		{
			// update max_change
			max_change = diff;

			// max index
			max_index = index;

			// now, we have stored the largest change in max_change
			// and the index of this day in max_index
		}
	}

	
	// Output
	//-------

	if (max_index > 0)
	{
		// there was an update
		cout << "Groesste Veraenderung: am " << max_index+1 << ". Tag : " << max_change << endl;
	} else {
		// there was no update
		cout << "Es hat keine Veraenderung stattgefunden" << endl;
	}


/////////////////////////////////////////////////////////////////////////////////
// Zwei grsste Anstiege
/////////////////////////////////////////////////////////////////////////////////

	// Declaration of variables
	//-------------------------

	// largest increase
	float	change1 = 0;
	int		index1 = -1;
	
	// 2nd largest increase
	float	change2 = 0;
	int		index2 = -1;

	// Search the array
	//-----------------

	// start at index 1!
	// if starting at index 0, we would access Temp[-1] which is not defined
	for (int index = 1; index<30; index++)
	{
		// determine difference
		float diff = Temp[index] - Temp[index - 1];

		// if diff is larger than change1 then 
		//    1. propagate change1 to change2 
		//    2. update change1

		// remark: no absolut value needed!
		if (diff > change1)
		{
			// propagate
			change2 = change1;
			index2 = index1;

			// set new value to change1
			change1 = diff;
			index1 = index;
		}
		// else if diff is only larger than change2 (and therefore smaller than change1) 
		// then only update the second value
		else if (diff > change2) 
		{
			change2 = diff;
			index2 = index;
		}    
	}

	// Output
	//-------

	if (index1 >= 0)
	{
		// there was a largest increase
		cout << "Groesster Anstieg: am " << index1+1 << ". Tag : " << change1 << endl;

		if (index2 >=0)
		{
			// there was also a second largest increase
			cout << "Zweigroesster Anstieg: am " << index2+1 << ". Tag : " << change2 << endl;
		} else {
			// there was no second largest increase
			cout << " Es hat keine zweite positive Veraenderung stattgefunden" << endl;
		}
	} else {
		// there was no increase
		cout << "Es hat keine positive Veraenderung stattgefunden" << endl;
	}

	// end
	return 0;
}

// generate temperature values
void loadValues(float* arr)
{
	// random seed
	srand( (unsigned)time( NULL ) );

	float start = 100.0;
	for (int i=0; i<30; i++)
	{
		// generate random values
		arr[i] = ((float)rand() / RAND_MAX) * 40 - 20.0f;

		// generate constant values
		//arr[i] = 12.0;
		
		// generate monotonic decreasing
		//arr[i] = start - ((float)rand() / RAND_MAX) * 5;
		//start = arr[i];

		// generate monotonic increasing
		//arr[i] = start + ((float)rand() / RAND_MAX) * 5;
		//start = arr[i];
	}
}
